<?php

namespace Drupal\edlp_home\Controller;

use Drupal\Core\Controller\ControllerBase;
use Drupal\Core\Datetime\DrupalDateTime;
use Drupal\taxonomy\Entity\Term;
use Drupal\workflow\Entity\WorkflowManager;
use Symfony\Component\HttpFoundation\JsonResponse;


class HomeController extends ControllerBase {

  /**
   * Display home as a page.
   *
   * @return renderable array
   */
  public function home() {

    // $view_builder = \Drupal::entityTypeManager()->getViewBuilder('node');

    $contents = array("#theme"=>'edlp_home');

    // first get static pages
    $query = \Drupal::entityQuery('node')
      ->condition('status', 1)
      ->condition('field_afficher_en_page_d_acceuil', 1)
      ->condition('type', 'static');

    $promoted_nids = $query->execute();
    $contents["#promoted_nodes"] = entity_load_multiple('node', $promoted_nids);

    // then get production pages
    $query = \Drupal::entityQuery('node')
      ->condition('status', 1)
      ->condition('field_afficher_en_page_d_acceuil', 1)
      ->condition('type', 'page');

    $promoted_nids = $query->execute();
    $contents["#promoted_nodes"] += entity_load_multiple('node', $promoted_nids);

    // presentation
    // $query = \Drupal::entityQuery('node')
    //   ->condition('status', 1)
    //   ->condition('nid', 12242);
    // // TODO: présentation nid should be a setting
    //
    // $pres_nid = $query->execute();
    // $contents["#presentation_node"] = entity_load('node', array_pop($pres_nid));

    // last fil
    // $query = \Drupal::entityQuery('node')
    //   ->condition('status', 1)
    //   ->condition('type', 'fil')
    //   ->sort('created', 'DESC')
    //   ->range(0,1);
    //
    // $fil = $query->execute();
    // $contents["#last_fil_node"] = entity_load('node', array_pop($fil));
    // $contents["#last_fil_node"] = array('#markup'=>'En développement.');


    // last production
    // $query = \Drupal::entityQuery('node')
    //   ->condition('status', 1)
    //   ->condition('type', 'page')
    //   ->condition('field_page_type', array('1168'), 'NOT IN')
    //   ->sort('created', 'DESC')
    //   ->range(0,1);
    //
    // $prod = $query->execute();
    // $contents["#last_production_node"] = entity_load('node', array_pop($prod));

    // agenda
    $now = new DrupalDateTime('now');
    $now->setTimezone(new \DateTimeZone(DATETIME_STORAGE_TIMEZONE));

    $query = \Drupal::entityQuery('node')
      ->condition('status', 1)
      ->condition('type', 'evenement')
      ->condition('field_date', $now->format(DATETIME_DATETIME_STORAGE_FORMAT), '>=')
      ->range(0,5)
      ->sort('field_date');

    $events = $query->execute();
    $contents['#agenda_items'] = entity_load_multiple('node', $events);

    return $contents;
  }
  /**
   * Display agenda as a page.
   *
   * @return renderable array
   */
  public function home_mobile() {

    // $view_builder = \Drupal::entityTypeManager()->getViewBuilder('node');

    $contents = array("#theme"=>'edlp_home');

    // first get static pages
    $query = \Drupal::entityQuery('node')
      ->condition('status', 1)
      ->condition('field_afficher_en_page_d_acceuil', 1)
      ->condition('type', 'static');

    $promoted_nids = $query->execute();
    $contents["#promoted_nodes"] = entity_load_multiple('node', $promoted_nids);

    // then get production pages
    $query = \Drupal::entityQuery('node')
      ->condition('status', 1)
      ->condition('field_afficher_en_page_d_acceuil', 1)
      ->condition('type', 'page');

    $promoted_nids = $query->execute();
    $contents["#promoted_nodes"] += entity_load_multiple('node', $promoted_nids);

    // last fil
    // $query = \Drupal::entityQuery('node')
    //   ->condition('status', 1)
    //   ->condition('type', 'fil')
    //   ->sort('created', 'DESC')
    //   ->range(0,1);
    //
    // $fil = $query->execute();
    // $contents["#last_fil_node"] = entity_load('node', array_pop($fil));
    // $contents["#last_fil_node"] = array('#markup'=>'En développement.');

    // agenda
    $now = new DrupalDateTime('now');
    $now->setTimezone(new \DateTimeZone(DATETIME_STORAGE_TIMEZONE));

    $query = \Drupal::entityQuery('node')
      ->condition('status', 1)
      ->condition('type', 'evenement')
      ->condition('field_date', $now->format(DATETIME_DATETIME_STORAGE_FORMAT), '>=')
      ->range(0,5)
      ->sort('field_date');

    $events = $query->execute();
    $contents['#agenda_items'] = entity_load_multiple('node', $events);


    // entrées
    $language = \Drupal::languageManager()->getCurrentLanguage()->getId();

    $query = \Drupal::entityQuery('taxonomy_term')
      // ->sort('weight', 'DESC')
      // ->sort('name', 'DESC')
      ->condition('vid', 'entrees');

    $tids = $query->execute();
    // $terms = entity_load_multiple('taxonomy_term', $tids);
    // $terms = \Drupal::entityManager()->getStorage('taxonomy_term')->loadMultiple($t‌​erms);
    $terms = Term::loadMultiple($tids);

    $ordered_terms = [];
    foreach ($terms as $term) {
      // remove masqué
      $sid = WorkflowManager::getCurrentStateId($term, 'field_workflow');
      if($sid == 'generique_masque') continue;
      // translate the term
      $term = \Drupal::service('entity.repository')->getTranslationFromContext($term, $language);
      $name = $term->getName();
      $ordered_trans_terms[$name] = $term;
    }

    ksort($ordered_trans_terms);

    // dsm($terms);
    // foreach ($ordered_trans_terms as $name => $term) {
    //   $tid = $term->id();
    //
    //   $entree = array(
    //     'tid'=>$tid
    //   );

      // term link
      // $url = Url::fromRoute('entity.taxonomy_term.canonical', ['taxonomy_term'=>$tid]);
      // $url->setOptions(array(
      //   'attributes' => array(
      //     'class' => ['term-'.$tid, 'term-link'],
      //     'tid'=>$tid,
      //     'selector' => 'entree-term-link-'.$tid,
      //     'data-drupal-link-system-path' => $url->getInternalPath()
      //   )
      // ));
      // $entree['term_link'] = Link::fromTextAndUrl($name, $url);
      // index link
      // $url = Url::fromRoute('entity.taxonomy_term.canonical', ['taxonomy_term'=>$tid]);
      // $url->setOptions(array(
      //   'attributes' => array(
      //     'class' => ['index-link', 'ajax-link'],
      //     'viewmode'=>'index',
      //     'tid'=>$tid,
      //     'selector' => 'entree-index-link-'.$tid,
      //     'data-drupal-link-system-path' => $url->getInternalPath()
      //   )
      // ));
      // $entree['index_link'] = Link::fromTextAndUrl('index', $url);

      // notice-link
      // $url = Url::fromRoute('entity.taxonomy_term.canonical', ['taxonomy_term'=>$tid]);
      // $url->setOptions(array(
      //   'attributes' => array(
      //     'class' => ['notice-link'],
      //     'viewmode'=>'notice',
      //     'tid'=>$tid,
      //     'selector' => 'entree-notice-link-'.$tid,
      //     'data-drupal-link-system-path' => $url->getInternalPath()
      //   )
      // ));
      // $entree['notice_link'] = Link::fromTextAndUrl('notice', $url);

    //   $entree['description'] = $term->get('description')->value;
    //
    //   $entrees[] = $entree;
    // }

    $contents['#entrees_items'] = $ordered_trans_terms;

    // = array (
    //   '#theme' => 'blockentrees',
    //   '#entrees_items' => $entrees,
    //   '#attached'=>array(
    //     'library' => array('edlp_corpus/corpus'),
    //     'drupalSettings' => array(
    //       'basepath' => base_path()
    //     )
    //   )
    // );


    return $contents;
  }

}
